//+------------------------------------------------------------------+
//|               Custom ##RCFilter version 2 adapted from MACD+OSMA |
//|                                         Copyright  2007, IT-Guy |
//|      Specific for use with Randy Candles System born at Forex-TSD|
//+------------------------------------------------------------------+
#property  copyright "Copyright  2007, IT-Guy"
//---- indicator settings
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 White
#property indicator_color4 DodgerBlue
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
//---- indicator parameters
extern int FastOsMA=26;
extern int SlowOsMA=34;
extern int SignalOsMA=13;
extern int FastMACD=7;
extern int SlowMACD=18;
extern int SignalMACD=5;
//---- indicator buffers
double ind_buffer1[];
double ind_buffer2[];
double ind_buffer3[];
double ind_buffer4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- 2 additional buffers are used for counting.
IndicatorBuffers(5);
//---- drawing settings
SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2);
SetIndexStyle(2,DRAW_LINE);
SetIndexStyle(3,DRAW_LINE);
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2 );
SetIndexDrawBegin(0,SignalOsMA);
SetIndexDrawBegin(1,SignalOsMA);
///---- 4 indicator buffers mapping
if(!SetIndexBuffer(0,ind_buffer1) &&
!SetIndexBuffer(1,ind_buffer2) &&
!SetIndexBuffer(2,ind_buffer3) &&
!SetIndexBuffer(3,ind_buffer4))
Print("cannot set indicators\' buffers!");
//---- name for DataWindow and indicator subwindow label
IndicatorShortName("RCFilter v2 RC-OsMA("+FastOsMA+","+SlowOsMA+","+SignalOsMA+")"+" RC-MACD("+FastMACD+","+SlowMACD+","+SignalMACD+")");
SetIndexLabel(0,"OSMA-RC");
SetIndexLabel(1,"OSMA-RC");
SetIndexLabel(2,"MACD-RC");
SetIndexLabel(3,"Signal");
//---- initialization done
return(0);
}
//+------------------------------------------------------------------+
//| Oscillator |
//+------------------------------------------------------------------+
int start()
{
int limit;
int counted_bars=IndicatorCounted();
double prev,current;
//---- check for possible errors
if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
if(counted_bars>0) counted_bars--;
limit=Bars-counted_bars;
//---- macd counted in the 1-st additional buffer
for(int i=0; i<limit; i++)
ind_buffer3[i]=iMA(NULL,0,FastMACD,0,MODE_EMA,PRICE_CLOSE,i)*1.5-iMA(NULL,0,SlowMACD,0,MODE_EMA,PRICE_CLOSE,i)*1.5;
//---- signal line counted in the 2-nd additional buffer
for(i=0; i<limit; i++)
ind_buffer4[i]=iMAOnArray(ind_buffer3,Bars,SignalMACD,0,MODE_SMA, i);
//---- dispatch values between 2 buffers
bool up=true;
for(i=limit-1; i>=0; i--)
{
current=iOsMA(NULL,0,FastOsMA,SlowOsMA,SignalOsMA,PRICE_MEDIAN,i);
prev=iOsMA(NULL,0,FastOsMA,SlowOsMA,SignalOsMA,PRICE_MEDIAN,i+1);
if(current>prev) up=true;
if(current<prev) up=false;
if(!up)
{
ind_buffer2[i]=3*current*2;
ind_buffer1[i]=0.0;
}
else
{
ind_buffer1[i]=3*current*2;
ind_buffer2[i]=0.0;
}
}
return(0);
}

